
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Grant_applicationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const grant_applications = await db.grant_applications.create(
            {
                id: data.id || undefined,
        
        application_reference: data.application_reference
        ||
        null
            ,
            
        submitted_at: data.submitted_at
        ||
        null
            ,
            
        requested_amount: data.requested_amount
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        proposal_summary: data.proposal_summary
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await grant_applications.setGrant( data.grant || null, {
            transaction,
        });
        
        await grant_applications.setBeneficiary( data.beneficiary || null, {
            transaction,
        });
        
        await grant_applications.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return grant_applications;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const grant_applicationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                application_reference: item.application_reference
            ||
            null
            ,
            
                submitted_at: item.submitted_at
            ||
            null
            ,
            
                requested_amount: item.requested_amount
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                proposal_summary: item.proposal_summary
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const grant_applications = await db.grant_applications.bulkCreate(grant_applicationsData, { transaction });

        // For each item created, replace relation files
        

        return grant_applications;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const grant_applications = await db.grant_applications.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.application_reference !== undefined) updatePayload.application_reference = data.application_reference;
        
        
        if (data.submitted_at !== undefined) updatePayload.submitted_at = data.submitted_at;
        
        
        if (data.requested_amount !== undefined) updatePayload.requested_amount = data.requested_amount;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.proposal_summary !== undefined) updatePayload.proposal_summary = data.proposal_summary;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await grant_applications.update(updatePayload, {transaction});

        
        
        if (data.grant !== undefined) {
            await grant_applications.setGrant(
              
              data.grant,
              
              { transaction }
            );
        }
        
        if (data.beneficiary !== undefined) {
            await grant_applications.setBeneficiary(
              
              data.beneficiary,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await grant_applications.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return grant_applications;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const grant_applications = await db.grant_applications.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of grant_applications) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of grant_applications) {
                await record.destroy({transaction});
            }
        });


        return grant_applications;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const grant_applications = await db.grant_applications.findByPk(id, options);

        await grant_applications.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await grant_applications.destroy({
            transaction
        });

        return grant_applications;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const grant_applications = await db.grant_applications.findOne(
            { where },
            { transaction },
        );

        if (!grant_applications) {
            return grant_applications;
        }

        const output = grant_applications.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.grant_evaluations_application = await grant_applications.getGrant_evaluations_application({
            transaction
        });
        
        
        output.grant_tranches_application = await grant_applications.getGrant_tranches_application({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        output.grant = await grant_applications.getGrant({
            transaction
        });
        
        
        output.beneficiary = await grant_applications.getBeneficiary({
            transaction
        });
        
        
        output.organizations = await grant_applications.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.grants,
        as: 'grant',
        
        where: filter.grant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.grant.split('|').map(term => Utils.uuid(term)) } },
            {
              call_reference: {
                [Op.or]: filter.grant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.beneficiaries,
        as: 'beneficiary',
        
        where: filter.beneficiary ? {
          [Op.or]: [
            { id: { [Op.in]: filter.beneficiary.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.beneficiary.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.application_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'grant_applications',
                        'application_reference',
                        filter.application_reference,
                    ),
                };
            }
            
            if (filter.proposal_summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'grant_applications',
                        'proposal_summary',
                        filter.proposal_summary,
                    ),
                };
            }
            

            
            

            
            if (filter.submitted_atRange) {
                const [start, end] = filter.submitted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    submitted_at: {
                    ...where.submitted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    submitted_at: {
                    ...where.submitted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.requested_amountRange) {
                const [start, end] = filter.requested_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    requested_amount: {
                    ...where.requested_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    requested_amount: {
                    ...where.requested_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.grant_applications.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'grant_applications',
                        'application_reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.grant_applications.findAll({
            attributes: [ 'id', 'application_reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['application_reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.application_reference,
        }));
    }

    
};

